#include <utility.h>

bool
convert_num(char *str, uint64_t *dst)
{
    char *endptr       = NULL;
    bool  good_convert = true;

    errno = 0; // reset errno

    if ((NULL == str) || (NULL == dst))
    {
        errno = EINVAL;
        perror("Invalid Options");
        goto END;
    }

    *dst = strtol(str, &endptr, BASE);

    if (0 != errno)
    {
        perror("Failed long conversion");
        goto END;
    }

    if (endptr == str)
    {
        errno = EINVAL;
        perror("No valid number found");
        goto END;
    }

    if ('\0' != *endptr)
    {
        errno = EINVAL;
        perror("Not all characters were converted");
        goto END;
    }
END:
    if (0 != errno)
    {
        good_convert = false;
    }

    return good_convert;
}

void
safe_close(int fd)
{
    if (0 != fd)
    {
        close(fd);
    }
}